#!/usr/bin/perl
#------------------------------------
# waitpid_test1.pl
use POSIX ":sys_wait_h";
$SIG{CHLD} = \&REAPER;
sub REAPER {
  my $pid;
  while (($pid = waitpid(-1, WNOHANG)) > 0) {
    # 进行一些处理
  }
}

sub child {
  print "I'm child, pid=$$.\n";
}

while (1) {
  if (fork() == 0) {
    &child;    # 如果当前进程是子进程，则执行 child 函数
	exit;      # 并退出
  } else {
    sleep 5;   # 如果是父进程，则睡眠 5 秒
  }
}
